## pqmarble 1.3.0

=== Makefile ===
.PHONY: all export install run clean fclean update hard-update test-run \
	ffclean test

MODULE := marble
APP_ID := com.raggesilver.Marble
MANIFEST := $(APP_ID).json

APP_DIR := app
BUILD_DIR := app_build
REPO_DIR := repo

BUILD_COMMAND := meson --prefix=/app $(BUILD_DIR)
INSTALL_COMMAND := ninja -C $(BUILD_DIR) install

# Running `make` will compile libmarble alone, which sets up app_build with
# $(BUILD_COMMAND). Running `make test` will make libmarble and also build it's
# test files, which requires setting up app_build again with -Dtests=true.
# $(TESTL) and $(BUILDL) are just two mock files used to know whether the last
# build was normal or a test build. Basically if one exists it indicates that
# was the last build type. I.e. if $(TESTL) exists, the latest build was a test
# build, so app_build won't be reconfigured. If it doesn't exist and you run
# `make test` this Makefile will `clean` before continuing, meaning any standard
# build will get erased.

TESTL := /tmp/a2db54691b025da102947a54fd50b258fced733a5a76ed29f5f4febb33faab7d
BUILDL := /tmp/26c0b68d4c11c2c97d2d6000fc198d3ae6bf19934c0090c935fcb61f7dab4597

all: $(BUILDL) $(MODULE)

$(MODULE): $(BUILD_DIR) Makefile
	@echo "::Building -- $@"
	flatpak-builder --run $(APP_DIR) $(MANIFEST) $(INSTALL_COMMAND)

# app_build/
$(BUILD_DIR): $(APP_DIR) Makefile
	@echo "::Building -- $@"
	flatpak-builder --run $(APP_DIR) $(MANIFEST) $(BUILD_COMMAND)

# app/
$(APP_DIR):
	@echo "::Building -- $@"
	flatpak-builder --disable-updates --stop-at=$(MODULE) $@ $(MANIFEST)

# test lock
$(TESTL):
	@$(MAKE) --no-print-directory clean
	@echo "::Starting a test build"
	@touch $@

# build lock
$(BUILDL):
	@$(MAKE) --no-print-directory clean
	@echo "::Starting a regular build"
	@touch $@

# update dependencies, use cache if unchanged
update:
	@echo "::Updating depenndencies"
	flatpak-builder --ccache --force-clean --stop-at=$(MODULE) $(APP_DIR) $(MANIFEST)

# update all dependencies without cache (will rebuild everything) even if there
# is nothing new
hard-update:
	@echo "::Hard updating depenndencies"
	flatpak-builder --disable-cache --force-clean --stop-at=$(MODULE) $(APP_DIR) $(MANIFEST)

# generate $(REPO_DIR) and $(MODULE).flatpak
# export: $(MODULE)
# 	@echo "::Exporting"
# 	@echo "::Finishing -- $(MODULE)"
# 	flatpak-builder --finish-only $(APP_DIR) $(MANIFEST)
# 	@echo "::Exporting -- $(MANIFEST)"
# 	flatpak-builder --export-only --repo=$(REPO_DIR) $(APP_DIR) $(MANIFEST)
# 	@echo "::Building bundle -- $(MODULE).flatpak"
# 	flatpak build-bundle $(REPO_DIR) "$(MODULE).flatpak" $(APP_ID)

# install $(MODULE).flatpak
# install: export
# 	@echo "::Installing -- $(MODULE).flatpak"
# 	flatpak install --user "$(MODULE).flatpak"

# remove $(BUILD_DIR), $(REPO_DIR) and $(MODULE).flatpak
clean:
	@echo "::Cleaning previous build"
	@rm -rf $(BUILD_DIR)
	@rm -rf $(REPO_DIR)
	@rm -rf $(MODULE).flatpak
	@rm -f $(BUILDL)
	@rm -f $(TESTL)

# remove $(BUILD_DIR), $(REPO_DIR), $(MODULE).flatpak and $(APP_DIR)
fclean: clean
	@echo "::Cleaning flatpak dependencies"
	@rm -rf $(APP_DIR)

# remove everything from fclean plus .flatpak-builder
ffclean: fclean
	@echo "::Cleaning flatpak-builder's cache"
	@rm -rf .flatpak-builder

test: BUILD_COMMAND := meson --prefix=/app -Dtests=true $(BUILD_DIR)
test: $(TESTL)
test: $(MODULE)

# build (if necessary) and run $(MODULE) for 5 seconds
test-run: test
	flatpak-builder --run $(APP_DIR) $(MANIFEST) 'marble_test'

# some tests for this file
# make ffclean test-run export && make ffclean export
# make ffclean hard-update export
# make test-run; make update export

# keep this as reference:
# https://docs.flatpak.org/en/latest/flatpak-builder-command-reference.html

=== meson_options.txt ===
option('tests', type : 'boolean', value : false)

=== debian/changelog ===
pqmarble (1.3.0-6build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:40:29 +1100

pqmarble (1.3.0-6) unstable; urgency=medium

  * lintian E: pqmarble source: missing-build-dependency-for-dh-addon gir

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 20 Mar 2024 15:52:36 +0000

pqmarble (1.3.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063287

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 21:14:06 +0000

pqmarble (1.3.0-5) unstable; urgency=medium

  * Add build dependency on libgirepository1.0-dev
    for GObject-2.0.gir (closes: #1060947)

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 16 Jan 2024 20:08:34 +0000

pqmarble (1.3.0-4) unstable; urgency=medium

  * Revert fix (closes: #1052725)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 05 Oct 2023 11:43:29 +0100

pqmarble (1.3.0-3) unstable; urgency=medium

  * Altlinux patch fixes "Cannot convert from `unowned uint8[]' to
    `unowned string'" (closes: 1050011); thank you Vladimir Didenko.
    Represent patch as git commit instead of quilt patch, for convenience.

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 28 Aug 2023 12:21:36 +0100

pqmarble (1.3.0-2) unstable; urgency=medium

  * Set upstream metadata fields: Repository.
  * Note code derived from LGPL-3 granite code

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 23 Mar 2023 10:23:12 +0000

pqmarble (1.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1032845)

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 12 Mar 2023 22:13:38 +0000

=== debian/control ===
Source: pqmarble
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
Rules-Requires-Root: no
Build-Depends: dpkg-dev (>= 1.22.5),
	debhelper-compat (= 13),
	meson,
	valac,
	pkgconf | pkg-config,
	libglib2.0-dev, libgtk-4-dev,
	gobject-introspection, gobject-introspection-bin,
	libgirepository1.0-dev,
Standards-Version: 4.6.2
Homepage: https://gitlab.gnome.org/raggesilver/marble
Vcs-Browser: https://salsa.debian.org/debian/pqmarble
Vcs-Git: https://salsa.debian.org/debian/pqmarble.git

Package: libpqmarble-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpqmarble2t64 (= ${binary:Version}), ${misc:Depends},
	gir1.2-pqmarble-2 (= ${binary:Version})
Description: Development files for libpqmarble
 Paulo Queiroz's collection of useful functions and reusable widgets.
 .
 Development library.

Package: libpqmarble2t64
Provides: ${t64:Provides}
Replaces: libpqmarble2
Breaks: libpqmarble2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Collection of useful functions and reusable widgets
 Paulo Queiroz's collection of useful functions and reusable widgets.
 .
 Run-time dynamic shared library.

Package: gir1.2-pqmarble-2
Section: introspection
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpqmarble2t64 (= ${binary:Version}), ${misc:Depends}, ${gir:Depends}
Description: GObject introspection files for pqmarble
 Paulo Queiroz's collection of useful functions and reusable widgets.
 .
 This package contains the GObject-introspection data in binary typelib format.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson --with=gir

=== debian/watch ===
version=4
https://gitlab.gnome.org/raggesilver/marble/tags .*/marble-v?@ANY_VERSION@@ARCHIVE_EXT@
